arrayQC.plot<-function(alpha=0.05)
{
   require(RGtk2)
   require(LPE)
   require(cairoDevice)

   ## flag define #########
   
   alpha<<-alpha
   expinfo.flag<<-FALSE
   Normalization.flag<<-FALSE
   Raw.flag<<-FALSE
   cDNA.RAW<<-NULL
   exp.name<<-NULL
   high.chip.list<<-NULL
   high.gene.list<<-NULL
   cDNA.Norm<<-NULL
   Result.Save<<-NULL
   chip.info<<-NULL

   name.Gf.flag<<-FALSE
   name.Gb.flag<<-FALSE
   name.Rf.flag<<-FALSE
   name.Rb.flag<<-FALSE
   name.print.tip.row.flag<<-FALSE
   name.print.tip.col.flag<<-FALSE
   name.gene.flag<<-FALSE

   chipListSelectRow.handler <- function(w, r, c, e, u = NULL)
   {
#      print(paste("select",r))
      high.chip.list<<-sort(c(high.chip.list,(r+1)))
   }
 
   chipListUnselectRow.handler <- function(w, r, c, e, u = NULL)
   {
#      print(paste("unselect",r))
      high.chip.list<<-t(as.matrix(high.chip.list[high.chip.list!=(r+1)]))
   }  

   geneListSelectRow.handler <- function(w, r, c, e, u = NULL)
   {
      high.gene.list<<-sort(c(high.gene.list,(r+1)))
   }

   geneListUnselectRow.handler <- function(w, r, c, e, u = NULL)
   {
      high.gene.list<<-t(as.matrix(high.gene.list[high.gene.list!=(r+1)]))
   }  

#####
Mnu.cDNA.Raw.handler<-function(w,u=NULL)
   {
      name.Gf<<-NULL
      name.Gb<<-NULL
      name.Rf<<-NULL
      name.Rb<<-NULL
      name.print.tip.row<<-NULL
      name.print.tip.col<<-NULL
      name.gene<<-NULL
      inut.sep<<-NULL
      skip.input<<-NULL
      ok.handler<-function(w,u=NULL)
      {
        name.Gf<<-gtkEntryGetText(name.Gf.p)
        name.Gb<<-gtkEntryGetText(name.Gb.p)
        name.Rf<<-gtkEntryGetText(name.Rf.p)
        name.Rb<<-gtkEntryGetText(name.Rb.p)
        name.print.tip.row<<-gtkEntryGetText(name.print.tip.row.p)
        name.print.tip.col<<-gtkEntryGetText(name.print.tip.col.p)
        name.gene<<-gtkEntryGetText(name.gene.p)
        input.sep<<-gtkEntryGetText(input.sep.p)
        if(tolower(input.sep)=="tab") input.sep<<-"\t";
        skip.input<<-as.numeric(gtkEntryGetText(skip.p))
        list.name<<-c(name.gene,name.Gf,name.Rf,name.Gb,name.Rb,name.print.tip.row,name.print.tip.col)
        list.id<<-which(list.name!="")
        list.name<<-list.name[list.id]
        if(name.gene!="") name.gene.flag<<-TRUE
        if(name.Gf!="") name.Gf.flag<<-TRUE
        if(name.Gb!="") name.Gb.flag<<-TRUE
        if(name.Rf!="") name.Rf.flag<<-TRUE
        if(name.Rb!="") name.Rb.flag<<-TRUE
        if(name.print.tip.row!="") name.print.tip.row.flag<<-TRUE
        if(name.print.tip.col!="") name.print.tip.col.flag<<-TRUE
        Var.name.flag <<- TRUE
        variable$Hide()
        variable$Destroy()
        if(!(name.Gf.flag & name.Rf.flag) )
        {   warning.gtk("Need red and green intensities")
        } else
        {   cDNA.RAW<<-NULL
            win<- gtkFileSelection("Open cDNA.RAW Data file")
            ok <- win[["OkButton"]]
            cancel <- win[["CancelButton"]]
            ok$AddCallback("clicked", function(x) {
                fname<-win$GetFilename()
                if(substring(fname,nchar(fname))=="/")
                {  warning.gtk("Please select files")
                } else
                {  Y <- read.table(fname,header = TRUE, sep = input.sep,skip=skip.input)
                   temp.cDNA<-list(Y[,list.name])
                   colnames(temp.cDNA[[1]])<-c("gene.name","cy3f","cy5f","cy3b","cy5b","print.tip.row","print.tip.col")[list.id]
                   if(!name.gene.flag) 
                   {  temp.cDNA[[1]]<-cbind(c(1:nrow(temp.cDNA[[1]])),temp.cDNA[[1]])
                      colnames(temp.cDNA[[1]])[1]<-"gene.name"
                   }
                   contents <- paste(" Read ",fname, sep=" ")
                   contents <- paste(contents,"\n",sep=" ")
                   Result.Save<<-c(Result.Save,contents)

#                   gtkTextInsert(outputText, chars = contents, length = -1)            
#                   outputText$Thaw()

                   gtkTextBufferInsertAtCursor(new.text,contents)
                   gtkTextViewSetBuffer(outputText,new.text)

                   if(name.Gb.flag)
                   {  temp.cDNA[[1]]$cy3<-temp.cDNA[[1]]$cy3f-temp.cDNA[[1]]$cy3b
                      temp.cDNA[[1]]$cy3[temp.cDNA[[1]]$cy3<0]<-0
                   } else
                   {  temp.cDNA[[1]]$cy3<-ifelse(temp.cDNA[[1]]$cy3f>0,temp.cDNA[[1]]$cy3f,0)
                      temp.cDNA[[1]]$cy3f<-NA
                   }
                   if(name.Rb.flag)
                   {  temp.cDNA[[1]]$cy5<-temp.cDNA[[1]]$cy5f-temp.cDNA[[1]]$cy5b
                      temp.cDNA[[1]]$cy5[temp.cDNA[[1]]$cy5<0]<-0
                   } else
                   {  temp.cDNA[[1]]$cy5<-ifelse(temp.cDNA[[1]]$cy5f>0,temp.cDNA[[1]]$cy5f,0)
                      temp.cDNA[[1]]$cy5f<-NA
                   }
                   if(!(name.print.tip.row.flag | name.print.tip.col.flag))
                   {  temp.cDNA[[1]]$print.tip<-NA
                   } else if(name.print.tip.row.flag & name.print.tip.col.flag)
                   { temp.cDNA[[1]]$print.tip<-factor(paste(temp.cDNA[[1]]$print.tip.row,
                                                      temp.cDNA[[1]]$print.tip.col,sep=""))
                   } else if(name.print.tip.row.flag)
                   { temp.cDNA[[1]]$print.tip<-factor(temp.cDNA[[1]]$print.tip.row)
                   }else if(name.print.tip.col.flag)
                   { temp.cDNA[[1]]$print.tip<-factor(temp.cDNA[[1]]$print.tip.col)
                   }
                   cDNA.RAW<<-c(cDNA.RAW,temp.cDNA)
                   temp<-strsplit(fname,split="\\\\")[[1]]
                   exp.name<<-c(exp.name,strsplit(temp[length(temp)],split="\\.")[[1]][1])
                   Raw.flag<<-TRUE
                   cDNA.Norm.input<<-NULL
                   for(i in 1:length(cDNA.RAW))
                   {  temp<-log2(cDNA.RAW[[i]]$cy5/cDNA.RAW[[i]]$cy3)
                      temp[is.infinite(temp)]<-NA
                      cDNA.Norm.input<<-cbind(cDNA.Norm.input,temp)
                   }
                   rownames(cDNA.Norm.input)<-rownames(cDNA.RAW[[1]])
                }
                print(summary(temp.cDNA[[1]]))
            }) 
            cancel$AddCallback("clicked",function(x){
                cDNA.flag<<-TRUE
                gene.name<<-as.character(cDNA.RAW[[1]]$gene.name)
                showGeneNameList(geneList,gene.name)
                chip.info<<-makeChip.Info(exp.name)
                showChipNameList(chipList,chip.info)
                win$Hide()
               win$Destroy()
            }) 
        }
      }

   cancel.handler<-function(w,u=NULL)
   {
     Var.name.flag <<- FALSE
     variable$Hide()
     variable$Destroy()
   }
   variable <<- gtkWindow (show = FALSE) 
   box1 <- gtkHBox(FALSE, 3)
   box1$PackStart(gtkLabel("Green Foreground"))
   box1$PackEnd(name.Gf.p<<-gtkEntry())
   box2 <- gtkHBox(FALSE, 3)
   box2$PackStart(gtkLabel("Red Foreground  "))
   box2$PackEnd(name.Rf.p<<-gtkEntry())
   box3 <- gtkHBox(FALSE, 3)
   box3$PackStart(gtkLabel("Green Background"))
   box3$PackEnd(name.Gb.p<<-gtkEntry())
   box4 <- gtkHBox(FALSE, 3)
   box4$PackStart(gtkLabel("Red Background  "))
   box4$PackEnd(name.Rb.p<<-gtkEntry())
   box5 <- gtkHBox(FALSE, 3)
   box5$PackStart(gtkLabel("Print tip row       "))
   box5$PackEnd(name.print.tip.row.p<<-gtkEntry())
   box51 <- gtkHBox(FALSE, 3)
   box51$PackStart(gtkLabel("Print tip col        "))
   box51$PackEnd(name.print.tip.col.p<<-gtkEntry())
   box6 <- gtkHBox(FALSE, 3)
   box6$PackStart(gtkLabel("Gene Name       "))
   box6$PackEnd(name.gene.p<-gtkEntry())
   box7 <- gtkHBox(FALSE, 3)
   box7$PackStart(gtkLabel("File Separation  "))
   box7$PackEnd(input.sep.p<<-gtkEntry())
   box8 <- gtkHBox(FALSE, 3)
   box8$PackStart(gtkLabel("# of skip  "))
   box8$PackEnd(skip.p<<-gtkEntry())

   button.ok<-gtkButton("Ok")
   button.ok$SetUsize(50,25)
   button.cancel<-gtkButton("Cancel")
   button.cancel$SetUsize(50,25)
   gtkAddCallback(button.ok, "clicked", ok.handler)
   gtkAddCallback(button.cancel, "clicked", cancel.handler)
   Button<-gtkHBoxNew()
   gtkBoxPackStart(Button,button.ok,TRUE,FALSE,0)
   gtkBoxPackStart(Button,button.cancel,TRUE,FALSE,0)
   variable.box<-gtkVBoxNew(FALSE,3)
   gtkBoxPackStart(variable.box,box1,TRUE,FALSE,0)
   gtkBoxPackStart(variable.box,box2,TRUE,FALSE,0)
   gtkBoxPackStart(variable.box,box3,TRUE,FALSE,0)
   gtkBoxPackStart(variable.box,box4,TRUE,FALSE,0)
   gtkBoxPackStart(variable.box,box5,TRUE,FALSE,0)
   gtkBoxPackStart(variable.box,box51,TRUE,FALSE,0)
   gtkBoxPackStart(variable.box,box6,TRUE,FALSE,0)
   gtkBoxPackStart(variable.box,box7,TRUE,FALSE,0)
   gtkBoxPackStart(variable.box,box8,TRUE,FALSE,0)
   gtkBoxPackStart(variable.box,Button,TRUE,FALSE,0)
   variable$Add(variable.box)
   variable$Show()

   print("cDNA.RAW.handler")
  }

#####

removeMainList <- function(columnlist,n)
{
   for(i in 1:n)
     gtkCListRemove(chipList,i)
}


makeChip.Info<-function(exp.name)
{ if(!expinfo.flag)
  {  p<-length(exp.name)
     exp.info<-matrix(rep(" ",p*3),nrow=p)
  }
  chip.info<-as.character(exp.name)
  for(i in 1:ncol(exp.info))
   chip.info<-cbind(chip.info,as.character(exp.info[,i]))   
  return(chip.info)
}

showGeneNameList<- function(geneList,gene.list)
{
   for(i in 1: length(gene.list))
      gtkCListAppend(geneList,as.character(gene.list[i]))
}

showChipNameList<- function(chipList,chip.info)
{
   chipname.info<-cbind(1:nrow(chip.info),chip.info)
   for(i in 1: nrow(chip.info))
      gtkCListAppend(chipList,as.character(chipname.info[i,]))
}
 
####

Mnu.cDNA.Norm.handler<-function(w,u=NULL)
   {
   win<- gtkFileSelection("Open cDNA Normalized Data file")
   ok <- win[["OkButton"]]
   cancel <- win[["CancelButton"]]

   ok$AddCallback("clicked", function(x) {
         temp.cDNA<-read.table(temp.chip.name<<-win$GetFilename(),sep=",",header=T)
         contents <- paste(" Read ", temp.chip.name, sep=" ")
         contents <- paste(contents,"\n",sep=" ")
         Result.Save<<-c(Result.Save,contents)
#         gtkTextInsert(outputText, chars = contents, length = -1)
#         outputText$Thaw()
         gtkTextBufferInsertAtCursor(new.text,contents)
         gtkTextViewSetBuffer(outputText,new.text)

         cDNA.Norm.input<<-temp.cDNA[,-1]
         gene.name<<-as.character(temp.cDNA[,1])
         exp.name<<-colnames(cDNA.Norm.input)
         showGeneNameList(geneList,gene.name)
         chip.info<<-makeChip.Info(exp.name)
         showChipNameList(chipList,chip.info)
         win$Hide()
         win$Destroy()
    }) 
   cancel$AddCallback("clicked",function(x){
         win$Hide()
         win$Destroy()
    }) 
   print("cDNA.Norm.handler")
  }

###
Mnu.Exp.info.handler<-function(w,u=NULL)
   {
   high.chip.list<<-NULL
   win<- gtkFileSelection("Open Experimental information file")
   ok <- win[["OkButton"]]
   cancel <- win[["CancelButton"]]
   ok$AddCallback("clicked", function(x) {
         exp.info<<-read.table(exp.info.name<<-win$GetFilename(),header=T)
         contents <- paste(" Read ", exp.info.name, sep=" ")
         contents <- paste(contents,"\n",sep=" ")
         Result.Save<<-c(Result.Save,contents)
#         gtkTextInsert(outputText, chars = contents, length = -1)
#         outputText$Thaw()
         gtkTextBufferInsertAtCursor(new.text,contents)
         gtkTextViewSetBuffer(outputText,new.text)

         expinfo.flag<<-TRUE
         chip.info<<-makeChip.Info(exp.name)
         gtkCListClear(chipList)
         showChipNameList(chipList,chip.info)
         colnames(cDNA.Norm.input)<-rownames(exp.info)
         win$Hide()
         win$Destroy()
         expinfo.flag<<-TRUE
    }) 
   cancel$AddCallback("clicked", function(x) {
         win$Hide()
         win$Destroy()
         expinfo.flag<<-FALSE
   })

   print("Exp.Info.handler")
  }

Mnu.Result.Save.handler<-function(w,u=NULL)
   {
   if(is.null(Result.Save))
   {   warning.gtk(" Nothing to save...")
   } else
   {   win<- gtkFileSelection("Save Result as")
       ok <- win[["OkButton"]]
       cancel <- win[["CancelButton"]]
       ok$AddCallback("clicked", function(x) {
            file.name <- win$GetFilename()
            write.table(Result.Save,file.name,row.names=FALSE,col.names=FALSE,quote=FALSE)
            win$Hide()
            win$Destroy()
       }) 
   }

   print("Result.Save.handler")
  }

Mnu.Exit.handler <- function(w, u = NULL)
{
   main$Hide()
   main$Destroy()
   dev.off()
}


Mnu.RedvsGreen.plot.handler<-function(w,u=NULL)
   {
  if(!Raw.flag)
  { warning.gtk(" Raw data is needed!")
  } else
  { 
   if(length(high.chip.list)==0)
   {  warning.gtk(" Select at least one chip!") 
   } else
   { 
      chip.id<-high.chip.list
      n<-length(chip.id)
      par.n1<-round(sqrt(n))
      par.n2<-ifelse(n%%par.n1==0, n/par.n1,floor(n/par.n1)+1)
      par(mfrow=c(par.n1,par.n2),pty="s")
      for(i in 1:length(chip.id))
      plot(log2(cDNA.RAW[[chip.id[i]]]$cy3),log2(cDNA.RAW[[chip.id[i]]]$cy5),xlab="log(Green intensity)",ylab="log(Red intensity)",
          main=rownames(exp.info)[chip.id[i]]) 

  }
  }
   print("RedvsGreen Plot")
  }

Mnu.Box.plot.handler<-function(w,u=NULL)
   {
  if(length(high.chip.list)<=1)
  { warning.gtk(" Select more than one chip ")
  } else
  {    par(mfrow=c(1,1))
       if(Normalization.flag & Raw.flag)
       {  p<- length(high.chip.list)
          temp.data<-NULL
          for(i in 1:p)
             temp.data<-cbind(temp.data,cDNA.Norm[[high.chip.list[i]]]$m)
       } else
       { temp.data<-cDNA.Norm.input[,high.chip.list]
       }
       colnames(temp.data)<-as.character(rownames(exp.info)[high.chip.list])
       boxplot(data.frame(temp.data),xlab="experiment",ylab="expression value")
  }
   print("Box Plot")
  }

Mnu.MvA.plot.handler<-function(w,u=NULL)
   {
  if(!Raw.flag)
  { warning.gtk(" Raw data is needed!")
  } else
  { 
   if(length(high.chip.list)==0)
   {  warning.gtk(" Select at least one chip! ") 
   } else
   { 
      chip.id<-high.chip.list
      n<-length(chip.id)
      par.n1<-round(sqrt(n))
      par.n2<-ifelse(n%%par.n1==0, n/par.n1,floor(n/par.n1)+1)
      par(mfrow=c(par.n1,par.n2),pty="s")
      if(Normalization.flag)
      { for(i in 1:length(chip.id))
         plot(cDNA.Norm[[chip.id[i]]]$a,cDNA.Norm[[chip.id[i]]]$m,xlab="a",ylab="m",main=paste("MvA plot :",rownames(exp.info)[chip.id[i]],sep=""))
       } else
       { for(i in 1:length(chip.id))
         {  m<-log2(cDNA.RAW[[chip.id[i]]]$cy3/cDNA.RAW[[chip.id[i]]]$cy5)
            a<-log2(cDNA.RAW[[chip.id[i]]]$cy3*cDNA.RAW[[chip.id[i]]]$cy5)/2
           plot(a,m,main=paste("MvA : ",rownames(exp.info)[chip.id[i]],sep=""))
         }
       }
   }
  }

   print("MvA Plot")
  }

Mnu.Scatter.Red.plot.handler<-function(w,u=NULL)
   {
  if(!Raw.flag)
  { warning.gtk(" Raw data is needed!")
  } else
  {  if(length(high.chip.list)<= 1)
     {   warning.gtk(" Select at least two chips ")
     } else 
     {   par(mfrow=c(1,1))
         Red.data<-NULL 
         for(i in 1:length(high.chip.list))
            Red.data<-cbind(Red.data,cDNA.RAW[[high.chip.list[i]]]$cy5)
         colnames(Red.data)<-chip.info[c(high.chip.list),1]
         pairs(log2(Red.data),main="Raw RED Intensity")
     }
  }
   print("Scatter Red Plot")
  }

Mnu.Scatter.Green.plot.handler<-function(w,u=NULL)
   {
  if(!Raw.flag)
  { warning.gtk(" Raw data is needed!")
  } else
  {  if(length(high.chip.list)<= 1)
     {   warning.gtk(" Select at least two chips ")
     } else
     {   par(mfrow=c(1,1))
         Green.data<-NULL 
         for(i in 1:length(high.chip.list))
            Green.data<-cbind(Green.data,cDNA.RAW[[high.chip.list[i]]]$cy3)
         colnames(Green.data)<-chip.info[c(high.chip.list),1]
         pairs(log2(Green.data),main="Raw GREEN Intensity")
     }
  }

   print("Scatter Green Plot")
  }

Mnu.Scatter.Ratio.plot.handler<-function(w,u=NULL)
   {
    if(length(high.chip.list)<= 1)
    {   warning.gtk(" Select at least two chips ")
    } else
    {   par(mfrow=c(1,1))
        m.data<-NULL 
        if(Normalization.flag & Raw.flag)
        {  for(i in 1:length(high.chip.list))
             m.data<-cbind(m.data,cDNA.Norm[[high.chip.list[i]]]$m)
        }else
       { m.data<-cDNA.Norm.input[,high.chip.list]
       }
       colnames(m.data)<-chip.info[c(high.chip.list),1]
       pairs(m.data,main="Normalized log Ratio Intensity")
    }
   print("Scatter Ratio Plot")
  }


Mnu.Correlation.plot.handler<-function(w,u=NULL)
   {
  if(!Raw.flag )
  { warning.gtk(" Raw data is needed!")
  } else
  { 
     if(length(high.chip.list)< 1)
     {   warning.gtk(" Select chips ")
     } else
     {  # par(mfrow=c(1,1))
        plot.dma.qc(dmaQC(),type=1)
     }
  }
   print("Correlation Plot")
  }

Mnu.Diagnostic.plot.handler<-function(w,u=NULL)
   {
 if(!Raw.flag)
  { warning.gtk(" Raw data is needed!")
  } else
  {   if(length(high.chip.list)< 1)
     {   warning.gtk(" Select chips ")
     } else
     {  #  par(mfrow=c(1,1))
       plot.dma.qc(dmaQC(),type=2)
     }
  }

   print("Diagnostic Plot")
  }

Mnu.chipwise.plot.handler<-function(w,u=NULL)
   {
# if(!Raw.flag)
#  { warning.gtk(" Raw data is needed!")
#  } else
#  {
   if(length(high.chip.list)< 1)
     {   warning.gtk(" Select chips ")
     } else
     {  # par(mfrow=c(1,1))
         cor.data<-cor(cDNA.Norm.input[,high.chip.list],use="pairwise.complete.obs")
         corr.plot<-list()
         trt<-chip.info[high.chip.list,2]
         for(i in 1:nrow(cor.data))
        {  id<-which(trt==trt[i])
           id<-id[id!=i]
           corr.plot[[i]]<-cor.data[i,id]
        }
        title<-"Chip-Wise correlation plot"
        names(corr.plot)<-as.character(chip.info[high.chip.list,1])
        boxplot(corr.plot,xlab="chip",ylab="correlation",main=title,name=as.character(chip.info[1,]))
     }
#  }
   print("chipwise Plot")
  }

Mnu.summary.plot.handler<-function(w,u=NULL)
   {
#  if(!Raw.flag)
#  { warning.gtk(" Raw data is needed!")
#  } else
#  { 
   if(length(high.chip.list)< 1)
     {   warning.gtk(" Select chips ")
     } else
     {  #  par(mfrow=c(1,1))
          cor.data<-cor(cDNA.Norm.input[,high.chip.list],use="pairwise.complete.obs")
          trt<-chip.info[high.chip.list,2]
          rw<-NULL
          rb<-NULL
          for(i in 1:nrow(cor.data))
          {   id<-which(trt==trt[i])
              rb<-c(rb,mean(cor.data[i,-id]))
              id<-id[id!=i]
              rw<-c(rw,mean(cor.data[i,id]))
          }
          title<-"Summary plot"
          plot(1-rw,1-rb,xlab="1-within corr",ylab="1-between corr",type='n',main=title,xlim=range(c(1-rw,1-rb)),ylim=range(c(1-rw,1-rb)))

         text(1-rw, 1-rb,as.character(1:nrow(cor.data)))
         outlier<-cbind(1-rw,1-rb)[rw<rb,]
         points(outlier,pch=1,cex=2.5,col=2)
         abline(a=0,b=1)
     }
#  }

   print("summary Plot")
  }

Mnu.Corr1.test.handler<-function(w,u=NULL)
   {
  trt.info<-factor(exp.info[c(high.chip.list),1]) 
    if(length(table(trt.info))< 2)
    {   warning.gtk(" Select more chips with at least two different treatments ")
    } else
    { if(!Normalization.flag)
      {  cDNA.summary<-cDNA.Norm.input[,high.chip.list]
      }else
      {   cDNA.summary<-NULL
          for(i in 1:length(high.chip.list))
             cDNA.summary<-cbind(cDNA.summary,cDNA.Norm[[high.chip.list[i]]]$m)
      }

      trt<-chip.info[high.chip.list,2]
      contents<-c("\n\n********** Correlation test : Kolmogorov-Smirnov test **********\nSelected chips :")
      for(i in 1:length(table(trt)))
      {   id<-which(trt==names(table(trt))[i])
          chip.name<-rownames(exp.info)[high.chip.list[id]]
          chip.content<-" "
          for(j in 1:length(chip.name))
             chip.content<-paste(chip.content,as.character(chip.name[j]),",",sep=" ")
          
           contents<-c(contents,paste("\ntreatment ", names(table(trt))[i],":",chip.content,sep=" "))
     }
      cor.Method<-c("Pearson","Spearman")
      for(i in 1:ncol(cDNA.summary))
      {   temp<-is.na(cDNA.summary[,i])
          if(sum(temp) !=0)
          {  id<-which(is.na(cDNA.summary[,i]))
             cDNA.summary<-cDNA.summary[-id,]
          }
          temp<-abs((cDNA.summary[,i])==Inf)
          if(sum(temp) !=0)
          {  id<-which(abs(cDNA.summary[,i])==Inf)
             cDNA.summary<-cDNA.summary[-id,]
          }
      }
         k<-cor.Method[1]
         cor.data<-cor(cDNA.summary,use="pairwise.complete.obs",method=tolower(k))
         trt<-chip.info[high.chip.list,2]
         cor.data<-0.5*log((1+cor.data)/(1-cor.data))
         diag(cor.data)<-0
         rw<-list()
         for(i in 1:length(table(trt)))
         {  id<-which(trt==names(table(trt))[i])
            rw[[i]]<-c(cor.data[id,id])
            rw[[i]]<-rw[[i]][rw[[i]]!=0]
            rw[[i]]<-as.numeric(names(table(rw[[i]])))
         }
         p<-length(rw)
         par(mfrow=c(p,p))
         result.keep<-NULL
         Pvalue.table<-matrix(rep(NA,p*p),nrow=p)
         diag(Pvalue.table)<-1
         for(i in 1:p)
            for(j in 1:p)
            {  if(i !=j)
               {   temp<-ks.test(rw[[i]],rw[[j]],alternative="less")
                   Pvalue.table[i,j]<-temp$p.value
                   contents <- c(contents, as.character(c(paste("\nHa :treatment", names(table(trt))[[i]]," is less than treatment",names(table(trt))[[j]],sep=" "))))
                   contents<-c(contents,as.character(c( paste(paste("D^- = ",round(as.numeric(temp[1]),4),sep=" "),
                                          paste("p-value = ",round(as.numeric(temp[2]),4),sep=" "),sep="\t\t"))))
                   n<-length(rw[[i]])
                   plot.range<-range(rw[[i]],rw[[j]])
                   title<-paste("ECDF's : ",k,"(P-value=",round(temp$p.value,3),")",sep="")
                   sub<-paste("Ha : dist. of trt", names(table(trt))[[i]]," < dist. of trt",
                                  names(table(trt))[[j]],sep=" ")
                   plot(ecdf(rw[[i]]), do.points=FALSE, 
                         verticals=TRUE,xlim=plot.range,lty=1,lwd=3,main=title,sub=sub,xlab="z-transf.(corr)")
                   lines(ecdf(rw[[j]]),do.points=FALSE,verticals=TRUE,lty=2,lwd=0.5)
                   legend(plot.range[1],1,as.character(paste("solid line : ",names(table(trt))[[i]],"\ndashed line : ",names(table(trt))[[j]])),cex=0.7)
                } else
                { plot(1,1,type='n',xlab=" ", ylab="",xaxt="n",yaxt="n")
                  text(1,1,as.character(paste("treatment ",names(table(trt))[[i]],sep=" ")),cex=1.5)
                }
            }

         colnames(Pvalue.table)<-names(table(trt))
         rownames(Pvalue.table)<-names(table(trt))
  
      for(i in contents) 
      {   chars <- paste(i, "\n")
          n <- nchar(chars)
#          gtkTextInsert(outputText, chars = chars, length = -1)
                  gtkTextBufferInsertAtCursor(new.text,contents)
                   gtkTextViewSetBuffer(outputText,new.text)

      }
       Result.Save<<-c(Result.Save,contents)
    }

   print("Corr1 test Plot")
  }

Mnu.Corr2.test.handler<-function(w,u=NULL)
   {
  trt.info<-factor(exp.info[c(high.chip.list),1]) 
    if(length(table(trt.info))< 2)
    {   warning.gtk(" Select more chips with at least two different treatments ")
    } else
    { if(!Normalization.flag)
      {  cDNA.summary<-cDNA.Norm.input;
      } else
      { cDNA.summary<-NULL
        for(i in 1:length(high.chip.list))
           cDNA.summary<-cbind(cDNA.summary,cDNA.Norm[[high.chip.list[i]]]$m)
      }

       trt<-chip.info[high.chip.list,2]
      contents<-c("\n\n********** Correlation test : Wilcoxon Rank Sum test **********\nSelected chips :")
      for(i in 1:length(table(trt)))
      {   id<-which(trt==names(table(trt))[i])
          chip.name<-rownames(exp.info)[high.chip.list[id]]
          chip.content<-" "
          for(j in 1:length(chip.name))
             chip.content<-paste(chip.content,as.character(chip.name[j]),",",sep=" ")
          
           contents<-c(contents,paste("\ntreatment ", names(table(trt))[i],":",chip.content,sep=" "))
      }
  
      cor.Method<-c("Pearson","Spearman")
      for(i in 1:ncol(cDNA.summary))
      {   temp<-is.na(cDNA.summary[,i])
          if(sum(temp) !=0)
          {  id<-which(is.na(cDNA.summary[,i]))
             cDNA.summary<-cDNA.summary[-id,]
          }
          temp<-abs((cDNA.summary[,i])==Inf)
          if(sum(temp) !=0)
          {  id<-which(abs(cDNA.summary[,i])==Inf)
             cDNA.summary<-cDNA.summary[-id,]
          }
      }
         k<-cor.Method[1]
         cor.data<-cor(cDNA.summary,use="pairwise.complete.obs",method=tolower(k))

         trt<-chip.info[high.chip.list,2]
         cor.data<-0.5*log((1+cor.data)/(1-cor.data))
         diag(cor.data)<-0
         rw<-list()
         for(i in 1:length(table(trt)))
         {  id<-which(trt==names(table(trt))[i])
            rw[[i]]<-c(cor.data[id,id])
            rw[[i]]<-rw[[i]][rw[[i]]!=0]
            rw[[i]]<-as.numeric(names(table(rw[[i]])))
         }  
         p<-length(rw)
         par(mfrow=c(1,p))
         result.keep<-NULL
         Pvalue.table<-matrix(rep(NA,p*p),nrow=p)
         diag(Pvalue.table)<-1
         for(i in 1:p)
            for(j in 1:p)
            {  if(i !=j)
               {   temp<-wilcox.test(rw[[i]],rw[[j]],alternative="greater")
                   Pvalue.table[i,j]<-temp$p.value
                   contents <- c(contents, as.character(c(paste("\nHa : mean of treatment", names(table(trt))[[i]]," is greater than mean of treatment",names(table(trt))[[j]],sep=" "))))
                   contents<-c(contents,as.character(c( paste(paste("W = ",round(as.numeric(temp[1]),4),sep=" "),
                                          paste("p-value = ",round(as.numeric(temp$p.value),4),sep=" "),sep="\t\t"))))
                   n<-length(rw[[i]])
                   plot.range<-range(rw[[i]],rw[[j]])
                   title<-paste(k," corr","(P-value=",round(temp$p.value,3),")",sep="")
                   sub<-paste("Ha : mean of trt", names(table(trt))[[i]]," >  mean of trt",
                                  names(table(trt))[[j]],sep=" ",cex=0.7)
                   plot.data<-cbind(rep(1,length(rw[[i]])),rw[[i]])
                   plot.data<-rbind(plot.data,cbind(rep(2,length(rw[[j]])),rw[[j]]))
                   plot.data[,1]<-factor(plot.data[,1])
                   plot(plot.data,xlim=c(0.5,2.5),ylim=plot.range,xaxt="n",ylab="correlation",xlab="",
                         main=title, cex=0.7,sub=sub)
                   axis(side=1,at=c(1,2),lab=names(table(trt))[c(i,j)])
                   points(1,mean(rw[[i]]),pch=4,cex=1.5)
                   points(2,mean(rw[[j]]),pch=4,cex=1.5)

             }
          }

         colnames(Pvalue.table)<-names(table(trt))
         rownames(Pvalue.table)<-names(table(trt))

##
    for(i in contents) 
    {   chars <- paste(i, "\n")
        n <- nchar(chars)
#        gtkTextInsert(outputText, chars = chars, length = -1)
                  gtkTextBufferInsertAtCursor(new.text,contents)
                   gtkTextViewSetBuffer(outputText,new.text)

    }
    Result.Save<<-c(Result.Save,contents)
}

   print("Corr2 test Plot")
  }

Mnu.Intensity.2.test.handler<-function(w,u=NULL)
{    trt.info<-factor(exp.info[c(high.chip.list),1]) 
    if(sum(table(trt.info)!=1)==0 )
    {   warning.gtk("Need at least two replicates in same treatment level ")
    } else
    {  if(!Raw.flag)
       {   data.norm<-cDNA.Norm.input[,high.chip.list]; 
       }else
       {   trt<-table(trt.info)
           data.norm<-NULL; data.A<-NULL
           for(i in 1:length(high.chip.list))
           {     data.norm<-cbind(data.norm,cDNA.Norm[[high.chip.list[i]]]$m)
                 data.A<-cbind(data.A,cDNA.Norm[[high.chip.list[i]]]$a)
           }
           colnames(data.norm)<-rownames(exp.info)[high.chip.list]
        }
        temp<-(apply(data.norm,1,function(x){sum(is.na(x))==ncol(data.norm)}))
 
        trt<-table(trt.info)

        for(k in 1:length(trt))
        {   id.trt<-which(trt.info==names(trt)[k])
            temp.norm<-data.norm[,id.trt]
            temp<-apply(temp.norm,1,function(x){sum(is.na(x))==ncol(temp.norm)})
            if(sum(temp)!=0)
            {  na.all.id<-which(temp)
               data.norm<-data.norm[-na.all.id,]
               if(Raw.flag) {data.A<-data.A[-na.all.id,]}
            }
        }
        data.LPE<-data.norm 
        for(k in 1:length(trt))
        {   id.trt<-which(trt.info==names(trt)[k])        
            for(i in id.trt)
            {   temp<-is.na(data.LPE[,i])
                if(sum(temp) !=0)
                {  id<-which(is.na(data.LPE[,i]))
                   data.LPE[id,i]<-apply(matrix(data.LPE[id,id.trt],ncol=length(data.LPE[1,id.trt])),1,function(x){median(x,na.rm=T)})
                   if(Raw.flag){data.A[id,i]<-apply(matrix(data.A[id,id.trt],ncol=length(data.A[1,id.trt])),1,function(x){median(x,na.rm=T)})}
              }
            }
        }
        colnames(data.norm)<-rownames(exp.info)[c(high.chip.list)]
        trt<-table(trt.info)
 
        #######################
        # Normalize using LPE
        ########################
        set.seed(0)
        trt<-table(trt.info)
        data.norm.keep<-data.norm
        for(i in 1:length(trt))
        {  id.temp<-which(trt.info==names(trt)[i])
           if(Raw.flag)
           { data.norm[,id.temp]<- data.norm[,id.temp]/sqrt(base.cDNA.error(data.LPE[,id.temp],data.A[,id.temp],q=0.01)[,3])
           } else
           { data.norm[,id.temp]<- data.norm[,id.temp]/sqrt(baseOlig.error(data.LPE[,id.temp],q=0.01)[,2])
           }            
        }

        ###################
        # Treatment-wise test
        ###################
        trt.name<-names(table(trt.info))
        p<-length(trt)
        within.name<-NULL
        disC.trt<-NULL
        for(i in 1:p)
        { within.diff<-NULL
          id<-which(trt.info==trt.name[i])
          temp.mean<-apply(data.norm[,id],1,function(x){mean(x,na.rm=T)})
          for(j in id)
             within.diff<-cbind(within.diff,data.norm[,j]-temp.mean)
          within.name<-c(within.name,trt.name[i])
             
          disC.trt<-cbind(disC.trt,(apply(within.diff**2,1,function(x){sum(x,na.rm=T)})))
          disC.trt[,i] <-disC.trt[,i] > qchisq(1-alpha,trt[i]-1)
        }
        pair.CD.trt<-cbind(within.name,apply(disC.trt,2,sum),nrow(within.diff)-apply(disC.trt,2,sum))

        pair.CD.trt<-cbind(pair.CD.trt,round(apply(pair.CD.trt,1,function(x){x<-as.numeric(x[2:3]);
                                                 return((x[2]-x[1])/(x[2]+x[1]))}),4))
        colnames(pair.CD.trt)<-c("pair.trt","pairD.trt","pairC.trt","gamma.trt")

         ###################
         # Parcoord plot
         ###################
      
         id<-NULL
         for(i in 1:length(trt))
             id<-c(id,which(trt.info==trt.name[i]))
         x<-data.norm[,id]
         x <- apply(x, 2, function(x){(x - min(x,na.rm=T))/(max(x,na.rm=T) - min(x,na.rm=T))})
         par(mfrow=c(1,length(trt)),mai=c(1,0,0.5,0))
         for(i in 1:length(trt))
        {    if(i==1)
             { id<- c(1:trt[1])
             } else
             { id<- c((sum(trt[1:(i-1)])+1):sum(trt[1:i]))
             }

             matplot(1:ncol(x[,id]), t(x[,id]), type = "l",col="grey70",axes=F,xlab="",ylab="",main=paste("Treatment",trt.name[i],sep=" : "))
             disC.id<-which(disC.trt[,i]==TRUE)
             for(k in disC.id)
                  lines(1:ncol(x[,id]),t(x[k,id]), col = 2)
             plot.label<-paste(rep(trt.name[i],trt[i]),colnames(x[,id]),sep=":")
             axis(1, at = c(1:ncol(x[,id])), labels = as.character(colnames(x[,id])),las=2)
         }
         par(mai=c(1.0211474, 0.8209224, 0.8209224, 0.4204724))

        ################
        # print output
        ################
        chip.name<-"Selected chips : "
        for(i in 1:length(high.chip.list))
            chip.name<-paste(chip.name,rownames(exp.info)[high.chip.list[i]],sep="  ")
        if(!Raw.flag)
        {  n.diff<-nrow(cDNA.Norm.input)-nrow(data.norm) 
        } else
        {  n.diff<-nrow(cDNA.RAW[[1]])-nrow(data.norm)
        }
        contents<-c("\n***** Differently expressed Gene : within treatment *****",
                     "*****                use Intensity                  *****\n",chip.name,
        paste(paste("   (delete", n.diff,sep=" "),"genes due to missing)",sep=" "))
        for(i in contents) 
        {   chars <- paste(i, "\n")
            n <- nchar(chars)
#            gtkTextInsert(outputText, chars = chars, length = -1)
                  gtkTextBufferInsertAtCursor(new.text,contents)
                   gtkTextViewSetBuffer(outputText,new.text)

        }
        Result.Save<<-c(Result.Save,contents)

        contents<-c("\nTest for each treatment")
        for(i in 1:nrow(pair.CD.trt))
        {  contents<-paste(contents,paste("\n Treatment :", pair.CD.trt[i,1],sep= " "),sep="")
           contents<-paste(contents,paste("\n    Concordant gene :", pair.CD.trt[i,3],sep= " "),sep="")
           contents<-paste(contents,paste("\n    Discordant gene :", pair.CD.trt[i,2],sep= " "),sep="")
           contents<-paste(contents,paste("\n    gamma           :", pair.CD.trt[i,4],sep= " "),sep="")
        }

        for(i in contents) 
        {   chars <- paste(i, "\n")
            n <- nchar(chars)
#            gtkTextInsert(outputText, chars = chars, length = -1)
                  gtkTextBufferInsertAtCursor(new.text,contents)
                   gtkTextViewSetBuffer(outputText,new.text)

        }
        Result.Save<<-c(Result.Save,contents)
     }

   print("Intensity 2 test Plot")
  }

Mnu.Normalization.handler<-function(w,u=NULL)
   {
      GPnorm.gtk()
      Normalization.flag<<-TRUE
 
   print("Normalization")
  }

Mnu.New.Plot.handler<-function(w,u=NULL)
   {   
      if(.Platform$OS.type=="unix")
      {  X11()
      }else
      {  Cairo()
      } 

   print("New plot")
  }
  
  warning.gtk <- function(messages) {
    warn.win <- gtkWindow(show = FALSE)
    box <- gtkVBox(TRUE, 0)
    box$SetUsize(-1, 80)
    box$PackStart(gtkLabel(messages))
    box$PackStart(box.small <- gtkHBox(FALSE, 0), expand = TRUE, fill = FALSE)
    box.small$PackStart(button <- gtkButton("Ok"), expand = TRUE, fill = FALSE)
    button$SetUsize(60, 25)
    button$AddCallback("clicked", function(x) {
      warn.win$Hide()
      warn.win$Destroy()
    })
    warn.win$Add(box)
    warn.win$Show()
  }

##############

dmaQC.stat <- function(x, new.distance) {
  d <-sqrt((x$weight.mean * x$mean)^2 + (x$weight.diff * x$diff)^2)
  m <- mean(d)
  sd <- sd(d)
  
  if (missing(new.distance))
    p.value <- pnorm(d, mean = m, sd = sd, lower.tail = FALSE)
  else
    p.value <- pnorm(new.distance, mean = m, sd = sd, lower.tail = FALSE)

  p.value
}

plot.dma.qc <- function(x, type = 1:2, name, 
                        main = "Quality of Microarray data",
                        lab.1 = list(xlab = "gamma",
                          ylab = "correlation of slide"),
                        lab.2 = list(xlab = "1 - mean of correlation",
                          ylab = "maximum difference of correlations"),
                        lim.1 = list(xlim = range(x$gamma),
                          ylim = c(min(0, x$cor), max(1, x$cor))),
                        lim.2 = list(xlim = c(min(0, x$mean), max(1, x$mean)),
                          ylim = c(min(0, x$diff), max(1, x$diff))),
                        sep.name.1 = 0.02, sep.name.2 = 0.02,
                        fullname = FALSE,
                        col.line = "#808080", col.point = 1,
                        col.text = "#808080", col.hl = 2, col.hltext = 4,
                        hlname = TRUE,
                        resolution = diff(lim.2$xlim) / 100,
                        lty = 1, pch = 1, stat = TRUE, alpha = 0.05, ...) {
  type <- as.integer(type)
  if (any(type > 2) || any(type < 1))
    stop("argument type must be 1 or 2.")
  if (missing(name))
    name <- as.character(high.chip.list)

  show <- c(FALSE, FALSE)
  show[type] <- TRUE

  if (show[1]) {
    plot.new()
    plot.window(xlim = lim.1$xlim + 2 * c(-sep.name.1, sep.name.1),
                ylim = lim.1$ylim)
    box()
    axis(1, x$gamma)
    axis(2, seq(lim.1$ylim[1], lim.1$ylim[2], length = 5))
    title(main = main, xlab = lab.1$xlab, ylab = lab.1$ylab)
    for (i in 1:ncol(x$cor)) {
      lines(x$gamma, x$cor[, i], col = col.line, lty = lty, ...)
      if (! is.null(name) && fullname) {
        text(min(x$gamma) - sep.name.1, x$cor[1, i], name[i],
             col = col.text, ...)
        text(max(x$gamma) + sep.name.1, x$cor[length(x$gamma), i],
             name[i], col = col.text, ...)
      }
    }
    if (stat) {
      p.value <- dmaQC.stat(x)
      if (any(p.value < alpha))
        for (i in seq(along = x$mean)[p.value < alpha]) {
          lines(x$gamma, x$cor[, i], col = col.hl)
          text(min(x$gamma) - sep.name.1, x$cor[1, i], name[i],
               col = col.hltext, ...)
          text(max(x$gamma) + sep.name.1, x$cor[length(x$gamma), i], name[i],
               col = col.hltext, ...)
        }
      }
  }

  if (show[2]) {
    plot(x$mean, x$diff, xlim = lim.2$xlim, ylim = lim.2$ylim, main = main,
         xlab = lab.2$xlab, ylab = lab.2$ylab, col = col.point, ...)
    if (! is.null(name) && fullname)
      text(x$mean + sep.name.2, x$diff, name, col = col.text, ...)
    if (stat) {
      xx <- seq(lim.2$xlim[1], lim.2$xlim[2], by = resolution)
      yy <- seq(lim.2$ylim[1], lim.2$ylim[2], by = resolution)
      d <- sqrt(outer((x$weight.mean * xx)^2, (x$weight.diff * yy)^2, "+"))
      p.value <- dmaQC.stat(x, d)
      contour(xx, yy, p.value, level = alpha, col = 3, add = TRUE, ...)
      p.value <- dmaQC.stat(x)
      if (any(p.value < alpha)) {
        points(x$mean[p.value < alpha], x$diff[p.value < alpha],
               pch = pch, cex = 2, col = col.hl)
        if (! is.null(name))
          text(x$mean[p.value < alpha] + sep.name.2, x$diff[p.value < alpha],
               name[p.value < alpha], col = col.hltext, ...)
      }
    }
  }
}
dmaQC1 <- function(gamma = 0:10 / 10, weight.mean = 1, weight.diff = 1) {
 
  x<-list()
  x$om<-NULL
  x$ocy3<-NULL
  x$m<-cDNA.Norm.input[,high.chip.list]
  mean.x<-apply(x$m,1,function(x){mean(x,na.rm=T)})
  x$ocy3<-matrix(rep( mean.x,ncol(x$m)),ncol=ncol(x$m),byrow=F)
  x$ocy5<-x$m
  x$om<-x$ocy5-x$ocy3


  z <- list()
  z$cor <- array(0, dim = c(length(gamma), ncol(x$m)))
  z$gamma <- gamma

  c <- x$om - x$m
  cy3 <- x$ocy3
  cy5 <- x$ocy5
  for ( i in seq(along = gamma) )
    for (j in 1:ncol(x$m))
      z$cor[i, j] <- cor(cy3[, j]+ gamma[i] * c[, j],
                         cy5[, j] - (1 - gamma[i]) * c[, j],
                         use = "complete.obs")
  
  z$mean <- 1 - colMeans(z$cor)
  z$diff <- apply(z$cor, 2, max) - apply(z$cor, 2, min)
  z$weight.mean <- weight.mean
  z$weight.diff <- weight.diff
  colnames(z$cor) <- colnames(x$m)

  class(z) <- "dma.qc"

  return(z)
}

dmaQC <- function(gamma = 0:10 / 10, weight.mean = 1, weight.diff = 1) {
 
  x<-list()
  x$m<-NULL
  x$om<-NULL
  x$ocy3<-NULL
  x$ocy5<-NULL
  for(i in 1:length(high.chip.list))
  {    if(!Normalization.flag)
       { x$m<-cbind(x$m,cDNA.Norm.input[,high.chip.list[i]])
       } else
       { x$m<-cbind(x$m,cDNA.Norm[[high.chip.list[i]]]$m)
       }
       x$ocy3<-cbind(x$ocy3,cDNA.RAW[[high.chip.list[i]]]$cy3)
       x$ocy5<-cbind(x$ocy5,cDNA.RAW[[high.chip.list[i]]]$cy5)
       x$om<-cbind(x$om,log2(cDNA.RAW[[high.chip.list[i]]]$cy5/
                           cDNA.RAW[[high.chip.list[i]]]$cy3))
    }
 


  z <- list()
  z$cor <- array(0, dim = c(length(gamma), ncol(x$m)))
  z$gamma <- gamma

  c <- x$om - x$m
  cy3 <- log(x$ocy3, 2)
  cy5 <- log(x$ocy5, 2)
  for ( i in seq(along = gamma) )
    for (j in 1:ncol(x$m))
      z$cor[i, j] <- cor(cy3[, j]+ gamma[i] * c[, j],
                         cy5[, j] - (1 - gamma[i]) * c[, j],
                         use = "complete.obs")
  
  z$mean <- 1 - colMeans(z$cor)
  z$diff <- apply(z$cor, 2, max) - apply(z$cor, 2, min)
  z$weight.mean <- weight.mean
  z$weight.diff <- weight.diff
  colnames(z$cor) <- colnames(x$m)

  class(z) <- "dma.qc"

  return(z)
}

GPnorm.gtk <- function(w, u) {
if(!Raw.flag)
{warning.gtk("Need RAW data with green/red foreground/background intensity")
}else
{
  ## Basic GTK+ window
    slide.num<-c(1:length(cDNA.RAW))
    warning.gtk <- function(messages) {
    warn.win <- gtkWindow(show = FALSE)
    box <- gtkVBox(TRUE, 0)
    box$SetUsize(-1, 80)
    box$PackStart(gtkLabel(messages))
    box$PackStart(box.small <- gtkHBox(FALSE, 0), expand = TRUE, fill = FALSE)
    box.small$PackStart(button <- gtkButton("Ok"), expand = TRUE, fill = FALSE)
    button$SetUsize(60, 25)
    button$AddCallback("clicked", function(x) {
      warn.win$Hide()
      warn.win$Destroy()
    })
    warn.win$Add(box)
    warn.win$Show()
  }

  ## Normalization functions
  make.MA <- function(cy3, cy5) {
    w <- options()$warn
    options(warn = -1)
    tmp <- data.frame(a = (log(cy3, 2) + log(cy5, 2)) / 2,
                      m = log(cy5, 2) - log(cy3, 2))
    options(warn = w)
    tmp$a[!is.finite(tmp$a)] <- NA
    tmp$m[!is.finite(tmp$m)] <- NA
    tmp
  }

  loc.global <- function(print.tip) {
    z <- list()

    progress.gtk$SetPercentage(0)
    Sys.sleep(1)
    for (i in 1:length(cDNA.TRAN)) {
      m <- make.MA(cDNA.TRAN[[i]]$cy3, cDNA.TRAN[[i]]$cy5)

      if (print.tip) {
        m$pt <- cDNA.TRAN[[i]]$print.tip
        ptlv <- levels(m$pt)
        for (j in ptlv) {
          med <- median(m$m[m$pt == j], na.rm = TRUE)
          m$m[m$pt == j] <- m$m[m$pt == j] - med
        }
      } else {
        med <- median(m$m, na.rm = TRUE)
        m$m - m$m - med
      }
      
      z[[i]] <- m
     progress.gtk$SetPercentage(i / length(slide.num))
    }

    attr(z, "N1") <- "global"

    z
  }
  
  loc.loess <- function(print.tip) {
    z <- list()

    count <- 0
    progress.gtk$SetPercentage(0)
    Sys.sleep(1)
    for (i in 1:length(cDNA.TRAN)) {
      m <- make.MA(cDNA.TRAN[[i]]$cy3, cDNA.TRAN[[i]]$cy5)
      rownames(m) <- 1:nrow(m)
      z[[i]] <- m

      count <- count + 1
      if (print.tip) {
        m$pt <- cDNA.TRAN[[i]]$print.tip
        ptlv <- levels(m$pt)
        for (j in ptlv) {
          rl <- residuals(loess(m ~ a, data = m, sub = (pt == j)))
          m[names(rl), "m"] <- rl
        }
        progress.gtk$SetPercentage(count / length(slide.num))
        Sys.sleep(1)
      } else {
        rl <- residuals(loess(m ~ a, data = m))
        m[names(rl), "m"] <- rl
        progress.gtk$SetPercentage(count / length(slide.num))
        Sys.sleep(1)
      }
      z[[i]] <- m
    }

    attr(z, "N1") <- "loess"
    z
  }

  scale.generic <- function(print.tip, use.mad) {
    ## norm1 must not be NULL

    progress.gtk$SetPercentage(0)
    Sys.sleep(1)

    nslide <- length(norm1)
    z <- norm1

    scale.fn <- if (use.mad) mad else sd
    loc.fn <- if (use.mad) median else mean
    if (print.tip) {
      center <- deviance <- list()
      for (i in 1:nslide) {
        center[[i]] <- tapply(norm1[[i]]$m, norm1[[i]]$pt, loc.fn,
                              na.rm = TRUE)
        deviance[[i]] <- tapply(norm1[[i]]$m, norm1[[i]]$pt, scale.fn,
                                na.rm = TRUE)
      }
      progress.gtk$SetPercentage(0.5)
      Sys.sleep(1)
      f <- function(x, m)
        exp(m - log(x))
      dev <- lapply(deviance, f, exp(mean(log(unlist(deviance)))))
      for (i in 1:nslide) {
        c <- d <- numeric(length(norm1[[i]]$m))
        l <- levels(norm1[[i]]$pt)
        for (j in l) {
          c[norm1[[i]]$pt == j] <- center[[i]][j]
          d[norm1[[i]]$pt == j] <- dev[[i]][j]
        }
        z[[i]]$m <- (norm1[[i]]$m - c) * d + c
      }                      
    } else {
      center <- deviance <- numeric(nslide)
      for (i in 1:nslide) {
        center[i] <- loc.fn(norm1[[i]]$m, na.rm = TRUE)
        deviance[i] <- scale.fn(norm1[[i]]$m, na.rm = TRUE)
      }
      progress.gtk$SetPercentage(0.5)
      Sys.sleep(1)
      dev <- exp(mean(log(deviance)) - log(deviance))
      for (i in 1:nslide)
        z[[i]]$m <- (norm1[[i]]$m - center[i]) * dev[i] + center[i]
    }
    progress.gtk$SetPercentage(1)
    attr(z, "N2") <- switch(use.mad, "mad", "sd")
    z
  }

  ## Drawing plots

  plot.loc <- function() {
    d <- cDNA.TRAN[[slide.loc]]
    m <- make.MA(d$cy3, d$cy5)
    plot(m$a, m$m, xlim = xlim.loc, ylim = ylim.loc, cex = 0.75)
    if (opt.drawline) {
      if (opt.useglobal) {
        if (opt.usept) {
          m$pt <- d$print.tip
          ptlv <- levels(m$pt)
          cols <- rainbow(length(ptlv))
          h <- tapply(m$m, m$pt, median, na.rm = TRUE)
          abline(h = h, col = cols)
        } else
          abline(h = median(m$m, na.rm = TRUE), col = 2)
      } else {
        if (opt.usept) {
          m$pt <- d$print.tip
          ptlv <- levels(m$pt)
          x <- seq(xlim.loc[1], xlim.loc[2], length = 15)
          cols <- rainbow(length(ptlv))
          for (i in seq(along = ptlv)) {
            l <- loess(m ~ a, data = m, sub = (pt   == ptlv[i]))
            y <- predict(l, x)
            lines(x, y, col = cols[i])
          }
        } else {
          l <- loess(m ~ a, data = m)
          x <- seq(xlim.loc[1], xlim.loc[2], length = 15)
          y <- predict(l, x)
          lines(x, y, col = 2)
        }
      }
    }
  }

  plot.scale <- function() {
    if (opt.slide.ptscale) {
      boxplot(m ~ pt, data = norm1[[slide.scale]], ylim = ylim.scale,
              cex = 0.75)
    } else {
      plot.new()
      plot.window(xlim = c(0.5, length(slide.num) + 0.5), ylim = ylim.scale)
      box()
      axis(1)
      axis(2)
      for (i in 1:(length(slide.num)))
        boxplot(norm1[[i]]$m, at = i, add = TRUE, cex = 0.75)
    }
  }
  
  ## Check basic setting
  
  if (is.null(slide.num)) {
    warning.gtk("  Invalid slide information for normalization!  ")
    return(NULL)
  }
  norm.frame <- environment()
  cDNA.TRAN <- cDNA.RAW[slide.num]

  ## Normalization function
  loc.norm <- loc.global
  
  ## result storage variables
  norm1 <- NULL
  norm2 <- NULL

  ## options variables
  opt.normpt <- FALSE
  opt.usept <- FALSE
  opt.useglobal <- TRUE
  opt.useptscale <- FALSE
  opt.usemad <- TRUE
  devices <- integer(2)
  slide.loc <- 1
  slide.scale <- 1
  xlim.loc <- c(0, 16)
  ylim.loc <- c(-10, 10)
  xlim.scale <- NULL
  ylim.scale <- NULL
  opt.drawline <- FALSE
  ylim.scale <- c(-3, 3)
  opt.slide.ptscale <- FALSE
  
  ## GTK+ variables
  progress <- NULL

  ## GTK+ window
  window.gtk <- gtkWindow(show = FALSE)
  window.gtk$SetTitle("Normalization cDNA microarray data")

  box.base <- gtkVBox(FALSE, 5)
  box.base$SetBorderWidth(5)

  progress.gtk <- gtkProgressBar()
  box.base$PackEnd(progress.gtk)

  notebook <- gtkNotebook()
  notebook$SetTabPos("top")

  ## Location normalization

  box.frame <- gtkVBox(FALSE, 5)
  box.frame$SetBorderWidth(5)
  frame <- gtkFrame("Location normalization options")
  frame$SetUsize(600, 300)
  box.small <- gtkHBox(TRUE, 5)
  box.small$SetBorderWidth(5)

  ### Basic options
  box.small2 <- gtkVBox(FALSE, 5)
  box.small2$SetUsize(100, 100)
  button <- gtkCheckButton("Use the print-tip information")
  button$AddCallback("clicked", function(x) {
    if (x$GetActive())
      opt.usept <<- TRUE
    else 
      opt.usept <<- FALSE
  })
  box.small2$PackStart(button)
  label.gtk <- gtkLabel("Normalization method:")
  label.gtk$SetAlignment(0, 0.5)
  box.small2$PackStart(label.gtk)
  button.gtk <- gtkRadioButton(NULL, "Use Global normalization")
  button.gtk$AddCallback("clicked", function(x) {
    if (x$GetActive()) {
      opt.useglobal <<- TRUE
      loc.norm <<- loc.global
    }
  })
  box.small2$PackStart(button.gtk)
  button.gtk <- gtkRadioButtonNewWithLabelFromWidget(button.gtk, "Use Loess normalization")
#   button.gtk2 <- gtkRadioButton(NULL, "Use Loess normalization")

  button.gtk$AddCallback("clicked", function(x) {
    if (x$GetActive()) {
      opt.useglobal <<- FALSE
      loc.norm <<- loc.loess
    }
  })
  box.small2$PackStart(button.gtk)
  button.plot.loc.gtk <- gtkCheckButton("See the plot")
  button.plot.loc.gtk$AddCallback("clicked", function(x) {
    if (button.plot.loc.gtk$GetActive()) {
      frame.loc.gtk$SetSensitive(TRUE)
      dev.set(devices[1])
      par(mai = c(0.4, 0.4, 0.1, 0.1))
      plot.loc()
    } else
      frame.loc.gtk$SetSensitive(FALSE)
  })
  box.small2$PackStart(button.plot.loc.gtk)

  ### Plot options (deprecated)
  frame.loc.gtk <- gtkFrame("Plot options")
  box.small3 <- gtkHBox(FALSE, 0)
  box.small3$SetBorderWidth(5)

  box.small4 <- gtkVBox(TRUE, 0)
  box.small4$SetUsize(100, -1)
  box.small4$PackStart(button.gtk <- gtkCheckButton("Draw the line(s)"))
  button.gtk$AddCallback("clicked", function(x) {
    if (x$GetActive())
      opt.drawline <<- TRUE
    else
      opt.drawline <<- FALSE
    plot.loc()
  })
  box.small4$PackStart(label.gtk <- gtkLabel("Slide number:"))
  label.gtk$SetAlignment(0, 0.5)
  box.small4$PackStart(label.gtk <- gtkLabel("Range of x-axis:"))
  label.gtk$SetAlignment(0, 0.5)
  box.small4$PackStart(label.gtk <- gtkLabel("Range of y-axis:"))
  label.gtk$SetAlignment(0, 0.5)
  box.small3$PackStart(box.small4)

  box.small4 <- gtkVBox(TRUE, 0)
  box.small4$PackStart(gtkVBox())
  adjustment.gtk <- gtkAdjustment(1, 1, length(slide.num), 1, 1, 1)
  spin.slide.loc.gtk <- gtkSpinButton(adjustment.gtk,
                                      climb.rate = 0, digits = 0)
  spin.slide.loc.gtk$SetNumeric(TRUE)
  adjustment.gtk$AddCallback("value_changed", function(x) {
    slide.loc <<- spin.slide.loc.gtk$GetValueAsInt()
    dev.set(devices[1])
    plot.loc()
  })
  box.small4$PackStart(spin.slide.loc.gtk)
  adjustment.gtk <- gtkAdjustment(xlim.loc[1], -2, 18, 1, 5, 1)
  spin.xmin.loc.gtk <- gtkSpinButton(adjustment.gtk,
                                     climb.rate = 0, digits = 0)
  spin.xmin.loc.gtk$SetNumeric(TRUE)
  adjustment.gtk$AddCallback("value_changed", function(x) {
    r <- spin.xmin.loc.gtk$GetValueAsInt()
    if (r <= xlim.loc[2] - 1)
      xlim.loc[1] <<- r
    else {
      xlim.loc[1] <<- xlim.loc[2] - 1
      spin.xmin.loc.gtk$SetValue(xlim.loc[1])
    }
    dev.set(devices[1])
    plot.loc()
  })
  box.small4$PackStart(spin.xmin.loc.gtk)
  adjustment.gtk <- gtkAdjustment(ylim.loc[1], -10, 10, 1, 5, 1)
  spin.ymin.loc.gtk <- gtkSpinButton(adjustment.gtk,
                                     climb.rate = 0, digits = 0)
  spin.ymin.loc.gtk$SetNumeric(TRUE)
  adjustment.gtk$AddCallback("value_changed", function(x) {
    r <- spin.ymin.loc.gtk$GetValueAsInt()
    if (r <= ylim.loc[2] - 1)
      ylim.loc[1] <<- r
    else {
      ylim.loc[1] <<- ylim.loc[2] - 1
      spin.ymin.loc.gtk$SetValue(ylim.loc[1])
    }
    dev.set(devices[1])
    plot.loc()
  })
  box.small4$PackStart(spin.ymin.loc.gtk)
  box.small3$PackStart(box.small4)
  
  box.small4 <- gtkVBox(TRUE, 0)
  box.small4$PackStart(gtkVBox())
  box.small4$PackStart(gtkVBox())
  adjustment.gtk <- gtkAdjustment(xlim.loc[2], -2, 18, 1, 5, 1)
  spin.xmax.loc.gtk <- gtkSpinButton(adjustment.gtk,
                                     climb.rate = 0, digits = 0)
  adjustment.gtk$AddCallback("value_changed", function(x) {
    r <- spin.xmax.loc.gtk$GetValueAsInt()
    if (r >= xlim.loc[1] + 1)
      xlim.loc[2] <<- r
    else {
      xlim.loc[2] <<- xlim.loc[1] + 1
      spin.xmax.loc.gtk$SetValue(xlim.loc[2])
    }
    dev.set(devices[1])
    plot.loc()
  })
  box.small4$PackStart(spin.xmax.loc.gtk)
  adjustment.gtk <- gtkAdjustment(ylim.loc[2], -15, 15, 1, 5, 1)
  spin.ymax.loc.gtk <- gtkSpinButton(adjustment.gtk,
                                     climb.rate = 0, digits = 0)
  adjustment.gtk$AddCallback("value_changed", function(x) {
    r <- spin.ymax.loc.gtk$GetValueAsInt()
    if (r >= ylim.loc[1] + 1)
      ylim.loc[2] <<- r
    else {
      ylim.loc[2] <<- ylim.loc[1] + 1
      spin.ymax.loc.gtk$SetValue(ylim.loc[2])
    }
    dev.set(devices[1])
    plot.loc()
  })
  box.small4$PackStart(spin.ymax.loc.gtk)
  box.small3$PackStart(box.small4)

  frame.loc.gtk$Add(box.small3)
  frame.loc.gtk$SetSensitive(FALSE)
  
  box.small2$PackStart(frame.loc.gtk)
  box.small$PackStart(box.small2)

  ## Drawing Area
  ### need gtkDevice
  frame.drawing.loc.gtk <- gtkFrame("MA plot")
  frame.drawing.loc.gtk$SetUsize(300, 300)
  drawing.loc.gtk <- gtkDrawingArea()
  asCairoDevice(drawing.loc.gtk)
  devices[1] <- dev.cur()
  frame.drawing.loc.gtk$Add(drawing.loc.gtk)
  box.small$PackStart(frame.drawing.loc.gtk)
  frame$Add(box.small)  
  box.frame$PackStart(frame)

  ## Location normalization buttons
  box.small <- gtkHButtonBox()
  box.small$SetUsize(600, -1)
  box.small$SetLayout("end")
  button <- gtkButton("Start the normalization")
  button$AddCallback("clicked", function(x, data = list(opt.usept)) {
    button.accept.loc.gtk$SetSensitive(FALSE)
    button.accept.scale.gtk$SetSensitive(FALSE)
    norm1 <<- loc.norm(print.tip = opt.usept)
    norm2 <<- NULL
    if (opt.usept) {
      opt.normpt <<- TRUE
      opt.useptscale <<- TRUE
      button.pt.scale.gtk$SetActive(TRUE)
      button.pt.scale.gtk$SetSensitive(TRUE)      
    } else {
      opt.normpt <<- FALSE
      opt.useptscale <<- FALSE
      button.pt.scale.gtk$SetActive(FALSE)
      button.pt.scale.gtk$SetSensitive(FALSE)
    }
    box.frame.scale.gtk$SetSensitive(TRUE)
    button.accept.loc.gtk$SetSensitive(TRUE)
  })
  box.small$Add(button)
  
  button.accept.loc.gtk <- gtkButton("Accept")
  button.accept.loc.gtk$AddCallback("clicked", function(x) {
    if (is.null(norm1)) {
      warning.gtk("  You have no normalized data!  ")
    } else {
      cDNA.Norm <<- norm1
      dev.off(devices[1])
      dev.off(devices[2])      
      window.gtk$Hide()
      window.gtk$Destroy()
    }
  })
  button.accept.loc.gtk$SetSensitive(FALSE)
  box.small$Add(button.accept.loc.gtk)

  button.gtk <- gtkButton("Cancel")
  button.gtk$AddCallback("clicked", function(x) {
    dev.off(devices[1])
    dev.off(devices[2])      
    window.gtk$Hide()
    window.gtk$Destroy()
  })
  box.small$Add(button.gtk)

  box.frame$PackStart(box.small)
  
  notebook$AppendPage(box.frame, gtkLabel("Location"))

  ##
  ## Scale normalization
  
  box.frame.scale.gtk <- gtkVBox(FALSE, 5)
  frame.gtk <- gtkFrame("Scale normalization option")
  frame.gtk$SetUsize(600, 300)
  box.frame.scale.gtk$SetBorderWidth(5)

  box.small <- gtkHBox(TRUE, 5)
  box.small$SetBorderWidth(5)
  
  box.small2 <- gtkVBox(FALSE, 5)

  button.pt.scale.gtk <- gtkCheckButton("Scale normalization with print-tip")
  button.pt.scale.gtk$AddCallback("clicked", function(x) {
    if (x$GetActive()) {
      if (opt.normpt)
        opt.useptscale <<- TRUE
      else {
        warning.gtk("  You must normalize with print-tip when the location normalization!  ")
        x$SetActive(FALSE)
      }
    } else 
      opt.useptscale <<- FALSE
  })
  box.small2$PackStart(button.pt.scale.gtk)

  label.gtk <- gtkLabel("Scale measure:")
  label.gtk$SetAlignment(0, 0.5)
  box.small2$PackStart(label.gtk)
  
  button.gtk <- gtkRadioButton(NULL, "Use Median Absolute Deviation (MAD)")
  button.gtk$AddCallback("clicked", function(x) {
    if (x$GetActive())
      opt.usemad <<- TRUE
  })
  box.small2$PackStart(button.gtk)
  button.gtk <- gtkRadioButtonNewWithLabelFromWidget(button.gtk, "Use Standard Deviation (SD)")
  button.gtk$AddCallback("clicked", function(x) {
    if (x$GetActive())
      opt.usemad <<- FALSE
  })
  box.small2$PackStart(button.gtk)

  button.gtk <- gtkCheckButton("See the plot")
  button.gtk$AddCallback("clicked", function(x) {
    if (x$GetActive()) {
      frame.scale.gtk$SetSensitive(TRUE)
      dev.set(devices[2])
      par(mai = c(0.4, 0.4, 0.1, 0.1))
      plot.scale()
    } else {
      frame.scale.gtk$SetSensitive(FALSE)
    }
  })
  box.small2$PackStart(button.gtk)

  ### Plot options (deprecated)
  frame.scale.gtk <- gtkFrame("Plot options")
  box.small3 <- gtkHBox(FALSE, 0)
  box.small3$SetBorderWidth(5)
  
  box.small4 <- gtkVBox(TRUE, 0)
  box.small4$SetUsize(150, -1)
  box.small4$PackStart(button.gtk <- gtkCheckButton("As print-tip infomation"))
  button.gtk$AddCallback("clicked", function(x) {
    if (x$GetActive()) {
      opt.slide.ptscale <<- TRUE
      label.slide.scale.gtk$SetSensitive(TRUE)
      spin.slide.scale.gtk$SetSensitive(TRUE)
    } else {
      opt.slide.ptscale <<- FALSE
      label.slide.scale.gtk$SetSensitive(FALSE)
      spin.slide.scale.gtk$SetSensitive(FALSE)
    }
    dev.set(devices[2])
    plot.scale()
  })
  box.small4$PackStart(label.slide.scale.gtk <- gtkLabel("Slide number:"))
  label.slide.scale.gtk$SetAlignment(0, 0.5)
  label.slide.scale.gtk$SetSensitive(FALSE)
  box.small4$PackStart(label.gtk <- gtkLabel("Range of y-axis:"))
  label.gtk$SetAlignment(0, 0.5)
  box.small3$PackStart(box.small4)

  box.small4 <- gtkVBox(TRUE, 0)
  box.small4$PackStart(gtkVBox())
  adjustment.gtk <- gtkAdjustment(slide.scale, 1, length(slide.num), 1, 1, 1)
  spin.slide.scale.gtk <- gtkSpinButton(adjustment.gtk,
                                        climb.rate = 0, digits = 0)
  adjustment.gtk$AddCallback("value_changed", function(x) {
    slide.scale <<- spin.slide.scale.gtk$GetValueAsInt()
    dev.set(devices[2])
    plot.scale()
  })
  spin.slide.scale.gtk$SetSensitive(FALSE)
  box.small4$PackStart(spin.slide.scale.gtk)
  adjustment.gtk <- gtkAdjustment(ylim.scale[1], -15, 15, 1, 5, 1)
  spin.ymin.scale.gtk <- gtkSpinButton(adjustment.gtk,
                                       climb.rate = 0, digits = 0)
  adjustment.gtk$AddCallback("value_changed", function(x) {
    r <- spin.ymin.scale.gtk$GetValueAsInt()
    if (r <= ylim.scale[2] - 1)
      ylim.scale[1] <<- r
    else {
      ylim.scale[1] <<- ylim.scale[2] - 1
      spin.ymin.scale.gtk$SetValue(ylim.scale[1])
    }
    dev.set(devices[2])
    plot.scale()
  })
  box.small4$PackStart(spin.ymin.scale.gtk)
  box.small3$PackStart(box.small4)
  
  box.small4 <- gtkVBox(TRUE, 0)
  box.small4$PackStart(gtkVBox())
  box.small4$PackStart(gtkVBox())
  adjustment.gtk <- gtkAdjustment(ylim.scale[2], -15, 15, 1, 5, 1)
  spin.ymax.scale.gtk <- gtkSpinButton(adjustment.gtk,
                                       climb.rate = 0, digits = 0)
  adjustment.gtk$AddCallback("value_changed", function(x) {
    r <- spin.ymax.scale.gtk$GetValueAsInt()
    if (r >= ylim.scale[1] + 1)
      ylim.scale[2] <<- r
    else {
      ylim.scale[2] <<- ylim.scale[1] + 1
      spin.ymax.scale.gtk$SetValue(ylim.scale[2])
    }
    dev.set(devices[2])
    plot.scale()
  })
  box.small4$PackStart(spin.ymax.scale.gtk)
  box.small3$PackStart(box.small4)

  frame.scale.gtk$Add(box.small3)
  frame.scale.gtk$SetSensitive(FALSE)
  
  box.small2$PackStart(frame.scale.gtk)
  box.small$PackStart(box.small2)

  ##
  ## Drawing area
  frame.drawing.scale.gtk <- gtkFrame("Box plot")
  frame.drawing.scale.gtk$SetUsize(300, 300)
  drawing.scale <- gtkDrawingArea()
  asCairoDevice(drawing.scale)
  devices[2] <- dev.cur()
  frame.drawing.scale.gtk$Add(drawing.scale)
  box.small$PackStart(frame.drawing.scale.gtk)

  frame.gtk$Add(box.small)  
  box.frame.scale.gtk$PackStart(frame.gtk)

  box.small <- gtkHButtonBox()
  box.small$SetUsize(600, -1)
  box.small$SetLayout("end")
  button <- gtkButton("Start the normalization")
  button$AddCallback("clicked", function(x, data = list(opt.usept)) {
    button.accept.scale.gtk$SetSensitive(FALSE)
    if (is.null(norm1))
      warning.gtk("  You must normalize first with location normalization")
    else
      norm2 <<- scale.generic(print.tip = opt.useptscale, use.mad = opt.usemad)
    button.accept.scale.gtk$SetSensitive(TRUE)
    button.accept.loc.gtk$SetSensitive(FALSE)
  })
  box.small$Add(button)
  
  button.accept.scale.gtk <- gtkButton("Accept")
  button.accept.scale.gtk$AddCallback("clicked", function(x) {
    if (is.null(norm2)) {
      warning.gtk("  You have no scale normalized data!  ")
    } else {
      cDNA.Norm <<- norm2
#      dev.off(devices[1])
#      dev.off(devices[2])
      window.gtk$Hide()
      window.gtk$Destroy()
    }
  })
  button.accept.scale.gtk$SetSensitive(FALSE)
  box.small$Add(button.accept.scale.gtk)

  button.gtk <- gtkButton("Cancel")
  button.gtk$AddCallback("clicked", function(x) {
    dev.off(devices[1])
    dev.off(devices[2])
    window.gtk$Hide()
    window.gtk$Destroy()
  })
  box.small$Add(button.gtk)
  
  box.frame.scale.gtk$PackStart(box.small)
  box.frame.scale.gtk$SetSensitive(FALSE)
  
  notebook$AppendPage(box.frame.scale.gtk, gtkLabel("Scale"))
  
  box.base$PackEnd(notebook)
  
  window.gtk$Add(box.base)
  window.gtk$Show()
}
}

baseOlig.error<-function (y, stats = median, q = 0.01, min.genes.int = 10, div.factor = 1) 
{
    baseline.step1 <- baseOlig.error.step1(y, stats = stats,q=q)
    baseline.step2 <- baseOlig.error.step2(y, stats = stats,
        baseline.step1, min.genes.int = min.genes.int, div.factor = div.factor)
    return(baseline.step2)
}



###
baseOlig.error.step1<- function (y, stats = median, q = 0.01, df = 10) 
{
    AM <- am.trans(y)
    A <- AM[, 1]
    M <- AM[, 2]
    median.y <- apply(y, 1, stats)
    quantile.A <- quantile(A, probs = seq(0, 1, q), na.rm = TRUE)
    quan.n <- length(quantile.A) - 1
    var.M <- rep(NA, length = quan.n)
    medianAs <- rep(NA, length = quan.n)
    if (sum(A == min(A)) > (q * length(A))) {
        tmpA <- A[!(A == min(A))]
        quantile.A <- c(min(A), quantile(tmpA, probs = seq(q, 
            1, q), na.rm = TRUE))
    }
    for (i in 2:(quan.n + 1)) {
        n.i <- length(!is.na(M[A > quantile.A[i - 1] & A <= quantile.A[i]]))
        mult.factor <- 0.5 * ((n.i - 0.5)/(n.i - 1))
        vect.temp<-A > quantile.A[i - 1] & A <= quantile.A[i]
        if(length(which(vect.temp))!=0)
       {     var.M[i - 1] <- mult.factor * var(M[vect.temp], na.rm = TRUE)
        } else
        { var.M[i-1]<-0
        }
        medianAs[i - 1] <- median(A[vect.temp], na.rm = TRUE)
    }
    var.M[1:which(var.M == max(var.M))] <- max(var.M)
    base.var <- cbind(A = medianAs, var.M = var.M)
    sm.spline <- smooth.spline(base.var[, 1], base.var[, 2], 
        df = df)
    var.genes <- fixbounds.predict.smooth.spline(sm.spline, median.y)$y
    basevar.step1 <- cbind(A = median.y, var.M = var.genes)
    ord.median <- order(basevar.step1[, 1])
    var.genes.ord <- basevar.step1[ord.median, ]
    return(var.genes.ord)
}

######
baseOlig.error.step2<-function (y, baseOlig.error.step1.res, df = 10, stats = median, 
    min.genes.int = 10, div.factor = 1) 
{
    AM <- am.trans(y)
    A <- AM[, 1]
    M <- AM[, 2]
    median.y <- apply(y, 1, stats)
    var.genes.ord <- baseOlig.error.step1.res
    genes.sub.int <- n.genes.adaptive.int(var.genes.ord, min.genes.int = min.genes.int, 
        div.factor = div.factor)
    j.start <- 1
    j.end <- 0
    var.M.adap <- rep(NA, length = length(genes.sub.int))
    medianAs.adap <- rep(NA, length = length(genes.sub.int))
    for (i in 2:(length(genes.sub.int) + 1)) {
        j.start <- j.end + 1
        j.end <- j.start + genes.sub.int[i - 1] - 1
        vect.temp <- (A > var.genes.ord[j.start, 1] & A <= var.genes.ord[j.end, 
            1])
        if(length(which(vect.temp))!=0)
        {  n.i <- length(!is.na(M[vect.temp]))
            mult.factor <- 0.5 * ((n.i - 0.5)/(n.i - 1))
           var.M.adap[i - 1] <- mult.factor * var(M[vect.temp], na.rm = TRUE)
           medianAs.adap[i - 1] <- median(A[vect.temp], na.rm = TRUE)
        } else
        { var.M.adap[i-1]<-0 
        }
    }
   var.M.adap[1:which(var.M.adap == max(var.M.adap))] <- max(var.M.adap)
    base.var.adap <- cbind(A.adap = medianAs.adap, var.M.adap = var.M.adap)
    sm.spline.adap <- smooth.spline(base.var.adap[, 1], base.var.adap[, 
        2], df = df)
    var.genes.adap <- fixbounds.predict.smooth.spline(sm.spline.adap, 
        median.y)$y
    basevar.all.adap <- cbind(A = median.y, var.M = var.genes.adap)
    return(basevar.all.adap)
}

base.cDNA.error<-function (M,A, stats = median, q = 0.01, min.genes.int = 10, div.factor = 1) 
{
    baseline.step1 <- base.cDNA.error.step1(M,A, stats = stats,q=q)
    baseline.step2 <- base.cDNA.error.step2(M,A, stats = stats,
        baseline.step1, min.genes.int = min.genes.int, div.factor = div.factor)
    return(baseline.step1)
}

base.cDNA.error.step1<-function (M,A, stats = median, q = 0.01, df = 10) 
{
 
    median.A <- apply(A, 1, function(x){stats(x,na.rm=T)})
    median.M <- apply(M, 1, function(x){stats(x,na.rm=T)})
    A<-c(A)
    M<-c(M)
    quantile.A <- quantile(A, probs = seq(0, 1, q), na.rm = TRUE)
    quan.n <- length(quantile.A) - 1
    var.M <- rep(NA, length = quan.n)
    medianAs <- rep(NA, length = quan.n)
    if (sum(A == min(A,na.rm=T),na.rm=T) > (q * length(A))) {
        tmpA <- A[!(A == min(A))]
        quantile.A <- c(min(A), quantile(tmpA, probs = seq(q, 
            1, q), na.rm = TRUE))
    }
    for (i in 2:(quan.n + 1)) {  
      var.M[i - 1] <- var(M[A > quantile.A[i - 1] & A <= quantile.A[i]], na.rm = TRUE)
      medianAs[i - 1] <- median(A[A > quantile.A[i - 1] & A <= 
            quantile.A[i]], na.rm = TRUE)
    }
#    plot(medianAs,var.M,main="plot")
    var.M[1:which(var.M == max(var.M))] <- max(var.M)
    base.var <- cbind(A = medianAs, var.M = var.M)
    sm.spline <- smooth.spline(base.var[, 1], base.var[, 2], df = df)
    NA.id<-which(is.na(median.A))
    var.genes <- rep(NA,length(median.A))
    if(length(NA.id)!=0)
    { var.genes[-NA.id]<-fixbounds.predict.smooth.spline(sm.spline, median.A[-NA.id])$y
    } else
    { var.genes<-fixbounds.predict.smooth.spline(sm.spline, median.A)$y
    }
    basevar.step1 <- cbind(A = median.A,M=median.M, var.M = var.genes)
    return(basevar.step1)
}
base.cDNA.error.step2<-function (M,A, base.cDNA.error.step1.res, df = 10, stats = median, 
    min.genes.int = 10, div.factor = 1) 
{
    median.A <- apply(A, 1, function(x){stats(x,na.rm=T)})
    median.M <- apply(M, 1, function(x){stats(x,na.rm=T)})
    A<-c(A)
    M<-c(M)
 
    var.genes.ord <- base.cDNA.error.step1.res[,-2]
    sort.id<-sort.list(var.genes.ord[,1])
    var.genes.ord<-var.genes.ord[sort.id,]
    genes.sub.int <- n.genes.adaptive.int(var.genes.ord, min.genes.int = min.genes.int, 
        div.factor = div.factor)
    j.start <- 1
    j.end <- 0
    var.M.adap <- rep(NA, length = length(genes.sub.int))
    medianAs.adap <- rep(NA, length = length(genes.sub.int))
    for (i in 2:(length(genes.sub.int) + 1)) {
        j.start <- j.end + 1
        j.end <- j.start + genes.sub.int[i - 1] - 1
        vect.temp <- (A > var.genes.ord[j.start, 1] & A <= var.genes.ord[j.end, 
            1])
        if(length(which(vect.temp))!=0)
        {  var.M.adap[i - 1] <- var(M[vect.temp], na.rm = TRUE)
           medianAs.adap[i - 1] <- median(A[vect.temp], na.rm = TRUE)
        } else
        { var.M.adap[i-1]<-0 
        }
    }
    var.M.adap[1:which(var.M.adap == max(var.M.adap))] <- max(var.M.adap)
    base.var.adap <- cbind(A.adap = medianAs.adap, var.M.adap = var.M.adap)
    sm.spline.adap <- smooth.spline(base.var.adap[, 1], base.var.adap[, 
        2], df = df)
    NA.id<-which(is.na(median.A))
    var.genes.adap<-rep(NA,length(median.A))
    if(length(NA.id)!=0)
    {  var.genes.adap[-NA.id] <- fixbounds.predict.smooth.spline(sm.spline.adap, 
        median.A[-NA.id])$y
    } else
    {  var.genes.adap <- fixbounds.predict.smooth.spline(sm.spline.adap,median.A)$y
    }
    basevar.all.adap <- cbind(A = median.A,M=median.M, var.M = var.genes.adap)
    return(basevar.all.adap)
}

lpe.cDNA<-function (x, y, basevar.x, basevar.y, df = 10, array.type = "cDNA", trim.percent = 5) 
{
    n1 <- ncol(x)
    n2 <- ncol(y)
    ngenes <- nrow(x)
    if (n1 < 2 | n2 < 2) {
        stop("No replicated arrays!")
    }
    if (n1 >= 2 | n2 >= 2) {
        var.x <- basevar.x[, 3]
        var.y <- basevar.y[, 3]
        median.x <- basevar.x[, 2]
        median.y <- basevar.y[, 2]
        median.diff <- median.x - median.y
        std.dev <- sqrt(1.57 * ((var.x/n1) + (var.y/n2)))
        z.stats <- median.diff/std.dev
        data.out <- data.frame(x = x, median.1 = median.x, std.dev.1 = sqrt(var.x), 
            y = y, median.2 = median.y, std.dev.2 = sqrt(var.y), 
            median.diff = median.diff, pooled.std.dev = std.dev, 
            z.stats = z.stats)
        return(data.out)
    }
}


#############

############################################
############################################
# Main GUI
############################################
###########################################


 #-----  Main Window  -----#
   main <<- gtkWindow (show = FALSE) 
   main$SetTitle("arrayQCplot")
   gtkWindowSetDefaultSize(main,750,450)
#   gtkWindowSetPolicy(main,TRUE,TRUE,FALSE)  #allow top level window resizable
   gtkWindowSetResizable(main,TRUE)
   main$SetUposition(40,100) #gtkWidgetSetUposition

 #-----  Gene List  -----#     (Temporary)
   geneList <<- gtkCListNew(1)
#   geneList<<-gtkListStoreNew(1)
   gtkCListSetColumnWidth(geneList,0,70)
   gtkCListColumnTitlesShow(geneList)
   label0 <- gtkLabelNew("Gene List")	
   gtkCListSetColumnWidget(geneList,0,label0)
   gtkCListColumnTitlesPassive(geneList)
   gtkCListSetColumnResizeable(geneList,0,FALSE)
   gtkCListSetSelectionMode(geneList,GtkSelectionMode[4])

#----- output screen -----#
    outputText <<- gtkTextViewNew()
    gtkTextViewSetEditable(outputText,FALSE)
#    outputText$SetEditable(FALSE)
    new.text<<-gtkTextBufferNew()  
 #-----  Chip List  -----#     (Temporary)
   chipList <<- gtkCListNew(3)
#   chipList<<-gtkListStoreNew(1)

   gtkCListSetColumnWidth(chipList,0,20)
   gtkCListSetColumnWidth(chipList,1,60) # chip name
   gtkCListSetColumnWidth(chipList,2,60) # treatment
  
   gtkCListColumnTitlesShow(chipList)
   label0 <- gtkLabelNew("Id")          ; 
   gtkCListSetColumnWidget(chipList,0,label0)
   label1 <- gtkLabelNew("Chip Name")   ; 
   gtkCListSetColumnWidget(chipList,1,label1)
   label2 <- gtkLabelNew("Treatment")   ; 
   gtkCListSetColumnWidget(chipList,2,label2)
 
   gtkCListColumnTitlesPassive(chipList)
   gtkCListSetSelectionMode(chipList,GtkSelectionMode[4])
   gtkCListSetColumnResizeable(chipList,0,FALSE)

 
#----- Scroll Window 1&2 -----#
 
   scrollwindow1 <- gtkScrolledWindowNew()	# to go into the geneList frame
   scrollwindow1$SetUsize(200,70)
   gtkScrolledWindowSetPolicy(scrollwindow1,GtkPolicyType[2],GtkPolicyType[2])
   scrollwindow1$Add(chipList)
   gtkContainerSetBorderWidth(scrollwindow1,7)

   scrollwindow2 <- gtkScrolledWindowNew()	# to go into the geneList frame
   scrollwindow2$SetUsize(150,70)
   gtkScrolledWindowSetPolicy(scrollwindow2,GtkPolicyType[2],GtkPolicyType[2])
   scrollwindow2$Add(geneList)
   gtkContainerSetBorderWidth(scrollwindow2,7)

   scrollwindow3 <- gtkScrolledWindowNew()	# to go into the geneList frame
   scrollwindow3$SetUsize(400,70)
   gtkScrolledWindowSetPolicy(scrollwindow3,GtkPolicyType[2],GtkPolicyType[2])
   scrollwindow3$Add(outputText)
   gtkContainerSetBorderWidth(scrollwindow3,7)


#-----------------------------------#
#               menu
#-----------------------------------#

   menu1 <- gtkMenuNew()

   menu2 <- gtkMenuNew()
   menu21 <- gtkMenuNew()
   menu23 <- gtkMenuNew()
   menu24 <- gtkMenuNew()

   menu3 <- gtkMenuNew()
   menu31 <- gtkMenuNew()
   menu32 <- gtkMenuNew()
 
#----------

   show1 <- gtkMenuItemNewWithLabel("File")
   item11 <- gtkMenuItemNewWithLabel("Read cDNA Raw data")
   item12 <- gtkMenuItemNewWithLabel("Read cDNA Normalized data")
   item13 <- gtkMenuItemNewWithLabel("Read Exp.Info")
   item14 <- gtkMenuItemNewWithLabel("Save Result")
   item15 <- gtkMenuItemNewWithLabel("Exit")

   show2 <- gtkMenuItemNewWithLabel("Plot")
   item21 <-gtkMenuItemNewWithLabel("Red vs. Green plot")
   item25 <-gtkMenuItemNewWithLabel("MvA plot")
   item22 <-gtkMenuItemNewWithLabel("Box plot")
   item23 <- gtkMenuItemNewWithLabel("Scatter plot matrix")
   item231 <- gtkMenuItemNewWithLabel("with Red")
   item232 <- gtkMenuItemNewWithLabel("with Green")
   item233 <- gtkMenuItemNewWithLabel("with Ratio")
   item24 <- gtkMenuItemNewWithLabel("Quality Control plot")
   item241 <- gtkMenuItemNewWithLabel("correlation plot")
   item242 <- gtkMenuItemNewWithLabel("diagnostic plot")
   item243 <- gtkMenuItemNewWithLabel("chip-wise correlation plot")
   item244 <- gtkMenuItemNewWithLabel("summary correlation plot")


   show3 <- gtkMenuItemNewWithLabel("ReproducibilityCheckTest")   
   item31 <- gtkMenuItemNewWithLabel("Correlation based approach")
   item311 <- gtkMenuItemNewWithLabel("K-S test with z-transformation")
   item312 <- gtkMenuItemNewWithLabel("mean test")

   item32<- gtkMenuItemNewWithLabel("Intensity based approach")
   item321 <-gtkMenuItemNewWithLabel("Within Treatment")
 
   show4 <- gtkMenuItemNewWithLabel("Normalization")

   show5 <- gtkMenuItemNewWithLabel("New Plot")


#-----------

   gtkMenuShellAppend(menu1,item11)
   gtkMenuShellAppend(menu1,item12)
   gtkMenuShellAppend(menu1,item13)
   gtkMenuShellAppend(menu1,item14)
   gtkMenuShellAppend(menu1,item15)

   gtkMenuShellAppend(menu2,item21)
   gtkMenuShellAppend(menu2,item22)
   gtkMenuShellAppend(menu2,item25)
   gtkMenuShellAppend(menu2,item23)   
   gtkMenuShellAppend(menu2,item24)

   gtkMenuShellAppend(menu23,item231)
   gtkMenuShellAppend(menu23,item232)
   gtkMenuShellAppend(menu23,item233)
   gtkMenuShellAppend(menu24,item241)
   gtkMenuShellAppend(menu24,item242)
   gtkMenuShellAppend(menu24,item243)
   gtkMenuShellAppend(menu24,item244)


   gtkMenuShellAppend(menu3,item31)
   gtkMenuShellAppend(menu31,item311)
   gtkMenuShellAppend(menu31,item312)
   gtkMenuShellAppend(menu3,item32)
   gtkMenuShellAppend(menu32,item321)

#------------

   gtkWidgetShow(show1)
   gtkWidgetShow(item11) 
   gtkWidgetShow(item12) 
   gtkWidgetShow(item13) 
   gtkWidgetShow(item14) 

   gtkWidgetShow(show2)    
   gtkWidgetShow(item21) 
   gtkWidgetShow(item22) 
   gtkWidgetShow(item23) 
   gtkWidgetShow(item24)
   gtkWidgetShow(item25) 
   gtkWidgetShow(item231) 
   gtkWidgetShow(item232)   
   gtkWidgetShow(item233) 
   gtkWidgetShow(item241) 
   gtkWidgetShow(item242) 
   gtkWidgetShow(item243) 
   gtkWidgetShow(item244) 

   gtkWidgetShow(show3)    
   gtkWidgetShow(item31) 
   gtkWidgetShow(item311) 
   gtkWidgetShow(item312) 
   gtkWidgetShow(item32) 
   gtkWidgetShow(item321) 

   gtkWidgetShow(show4)   
 
   gtkWidgetShow(show5)   

#-----------

   gtkMenuItemSetSubmenu(show1,menu1)
   gtkMenuItemSetSubmenu(show2,menu2)
   gtkMenuItemSetSubmenu(item23,menu23)
   gtkMenuItemSetSubmenu(item24,menu24)
   gtkMenuItemSetSubmenu(show3,menu3)  
   gtkMenuItemSetSubmenu(item31,menu31)

   gtkMenuItemSetSubmenu(item32,menu32)
 
#--------

   menuBar<-gtkMenuBarNew()
   gtkWidgetShow(menuBar)

   gtkMenuShellAppend(menuBar,show1)
   gtkMenuShellAppend(menuBar,show4)
   gtkMenuShellAppend(menuBar,show2)
   gtkMenuShellAppend(menuBar,show3)
   gtkMenuShellAppend(menuBar,show5)

#------ callback function

   gtkAddCallback(item11, "activate", Mnu.cDNA.Raw.handler)
   gtkAddCallback(item12, "activate", Mnu.cDNA.Norm.handler)
   gtkAddCallback(item13, "activate", Mnu.Exp.info.handler)
   gtkAddCallback(item14, "activate", Mnu.Result.Save.handler)
   gtkAddCallback(item15, "activate", Mnu.Exit.handler)

   gtkAddCallback(item21, "activate", Mnu.RedvsGreen.plot.handler)
   gtkAddCallback(item22, "activate", Mnu.Box.plot.handler)
   gtkAddCallback(item25, "activate", Mnu.MvA.plot.handler)
   gtkAddCallback(item231, "activate", Mnu.Scatter.Red.plot.handler)
   gtkAddCallback(item232, "activate", Mnu.Scatter.Green.plot.handler)
   gtkAddCallback(item233, "activate", Mnu.Scatter.Ratio.plot.handler)
   gtkAddCallback(item241, "activate", Mnu.Correlation.plot.handler)
   gtkAddCallback(item242, "activate", Mnu.Diagnostic.plot.handler)
   gtkAddCallback(item243, "activate", Mnu.chipwise.plot.handler)
   gtkAddCallback(item244, "activate", Mnu.summary.plot.handler)

   gtkAddCallback(item311, "activate", Mnu.Corr1.test.handler)
   gtkAddCallback(item312, "activate", Mnu.Corr2.test.handler)
   gtkAddCallback(item321, "activate", Mnu.Intensity.2.test.handler)

   gtkAddCallback(show4, "activate", Mnu.Normalization.handler)
   gtkAddCallback(show5, "activate", Mnu.New.Plot.handler)

   gtkAddCallback(geneList, "select-row", geneListSelectRow.handler)
   gtkAddCallback(geneList, "unselect-row", geneListUnselectRow.handler)
   gtkAddCallback(chipList, "select-row", chipListSelectRow.handler)
   gtkAddCallback(chipList, "unselect-row", chipListUnselectRow.handler)

   

#------------------------------------------------------------------#
#------------------------------------------------------------------#


#-----  Frames  -----#  
#-----  Frame : GeneList & Chip List -----#
   ChipListFrame <- gtkFrameNew("Chip List")
   gtkContainerAdd(ChipListFrame,scrollwindow1)
   gtkWidgetShow(ChipListFrame)

 #----- Frame : GeneList ----------#
   GeneListFrame <- gtkFrameNew("Gene List")
   gtkContainerAdd(GeneListFrame,scrollwindow2)
   gtkWidgetShow(GeneListFrame)

#----- Frame : OutputTable ---------#
   outputTableFrame<-gtkFrameNew("Result")
   gtkContainerAdd(outputTableFrame,scrollwindow3)
   gtkWidgetShow(outputTableFrame)



#----- Packing and Show -----#

   Hpan1 <-gtkHPanedNew(FALSE) # to put GeneListFrame & ChipListFrame together
   Hpan2 <- gtkHPanedNew(FALSE)	# to put Vpan & GeneInfoFrame together
 #   Hpan1 <-gtkHPanedNew(FALSE,1) # to put GeneListFrame & ChipListFrame together
#   Hpan2 <- gtkHPanedNew(FALSE,1)	# to put Vpan & GeneInfoFrame together
   gtkPanedPack1(Hpan1,ChipListFrame,TRUE,TRUE)
   gtkPanedPack2(Hpan1,GeneListFrame,TRUE,TRUE)
   Hpan1$Show()
   gtkPanedPack1(Hpan2,Hpan1,TRUE,TRUE)
   gtkPanedPack2(Hpan2,outputTableFrame,TRUE,TRUE)
   Hpan2$Show()
   mainLayout <- gtkVBoxNew(FALSE,0)
   gtkBoxPackStart(mainLayout,menuBar,FALSE,FALSE,0)
   gtkBoxPackStart(mainLayout,Hpan2,TRUE,TRUE,0)
   main$Add(mainLayout)
   main$Show()
}
